def compute_user_svm_rank(user_feature_vector_file, svm_prediction_file, user_svm_score_file):
  all_user_svm_score = []
  all_user_svm_score_dic = {}
  user_score_ranking = {}
  
  print "reading user svm prediction score ... "
  
  for line in file(svm_prediction_file):
    line = line[:-1]
    all_user_svm_score.append(float(line))
  
  print "calculating user svm prediction score ranking ... "
  
  line_count = 0
  for line in file(user_feature_vector_file):
    line = line[:-1]
    fields = line.split(' ')
    user = fields[0]

    all_user_svm_score_dic[user] = all_user_svm_score[line_count]
    line_count += 1

  ranked_user_svm_score = [(score, user) for (user, score) in all_user_svm_score_dic.items()]
  ranked_user_svm_score.sort()
  ranked_user_svm_score.reverse()

  print "output user svm score ranking file ... "
  
  out = file(user_svm_score_file, 'w')
  for score, user in ranked_user_svm_score[0:len(ranked_user_svm_score)]: 
    out.write('%s %f\n' % (user, score))

  print "Ending"