from math import *

def compute_recommend_sort(data, popDic):
  labels = []
  lst_userA = "="
  Records = []
  userRecRecords = ""
  
  userBAction = {}
  userBActionList = ""
  
  for line in data:
    (userA, userB, round, action) = line.split(' ')

    if userA == "USER_ID_A":
      continue

    if lst_userA == "=" or userA == lst_userA:
      key = (int(userA), int(userB))
      userBAction.setdefault(key, -1)
      userBAction[key] = popDic[userB]
    else:
      line = 1
      keys = userBAction.keys()
      keys.sort()	#dict may be no order, should sort by key
      for key in keys:
        if line == 1:
          userBActionList += str(userBAction[key])
          userRecRecords += str(key[1])
        else:
          userBActionList += " " + str(userBAction[key])
          userRecRecords += " " + str(key[1])
        line += 1
      labels.append(userBActionList)
      Records.append(userRecRecords)

      userBAction = {}
      userBActionList = ""
      userRecRecords = ""
      key = (int(userA), int(userB))
      userBAction.setdefault(key, -1)
      userBAction[key] = popDic[userB]

    lst_userA = userA

  #for the last group
  line = 1
  keys = userBAction.keys()
  keys.sort()	#dict may be no order, should sort by key
  for key in keys:
    if line == 1:
      userBActionList += str(userBAction[key])
      userRecRecords += str(key[1])
    else:
      userBActionList += " " + str(userBAction[key])
      userRecRecords += " " + str(key[1])
    line += 1
  labels.append(userBActionList)
  Records.append(userRecRecords)

  return labels, Records

def generate_svm_train_file(train_sort_File, user_feature_vector_File, user_popularity_File, user_svm_train_File):
  userB_feature_vector = {}
  popDic = {}
  
  print "-----reading train file ... "
  
  records = [line for line in file(train_sort_File)]
  
  print "-----reading feature vector file ... "
  
  for line in file(user_feature_vector_File):
    fields = line.split(' ')
    user = fields[0]
    userB_feature_vector[user] = line

  print "-----reading user popularity file ... "
  for line in file(user_popularity_File):
    user, popularity = line.split(' ')
    popDic[user] = float(popularity[:-1])

  print "-----compute recommend sort ... "
  
  labels, rec_records = compute_recommend_sort(records, popDic)

  print "-----generate svm train file ... "
  
  out = file(user_svm_train_File, 'w')
  line_count = 0
  for (userA_BList) in rec_records[0:len(rec_records)]:
    users = userA_BList.split(' ')
    score_list = labels[line_count]
    scores = score_list.split(' ')

    user_count = 0
    for score in scores[0:len(scores)]:
      user = users[user_count]
      feature_vector = userB_feature_vector[user]
      feature_vector = feature_vector[:-1]
      features = feature_vector.split(' ')
      out.write('%s qid:%d 1:%s 2:%s 3:%s 4:%s 5:%s # %s\n' % (score, line_count, features[1], features[2], features[3], features[4], features[5], user))
      user_count += 1

    line_count += 1

  print "Ending"