# sort the training data by userA and then userB
# @author: cheng yan 
# @date 20120821  

from math import sqrt

def train_sort(trainFile, sortFile):
  records = []
  rankedLine = []
  lineNum = 1
  
  lineList = [line for line in file(trainFile)]
  for line in lineList:
    if lineNum == 1:	#ignore the title in first line
      lineNum += 1
      continue

    records.append(line)
    lineNum += 1
  
  for line in records:   
    (userA_ID, userB_ID, times, action) = line.split(' ')  
    rankedLine.append((int(userA_ID), int(userB_ID), times, action[:-1]))

  rankedLine.sort()
  #rankedLine.reverse()
  
  out = file(sortFile, 'w')
  for (userA_ID, userB_ID, times, action) in rankedLine[0:len(rankedLine)]: 
    out.write('%d %d %s %s\n' % (userA_ID, userB_ID, times, action))
  
  return rankedLine